import { Node } from "typescript";
import { ComponentMember } from "../../types/component-member";
import { EventDeclaration } from "../../types/event-types";
import { ParseComponentFlavor, ParseComponentMembersContext, ParseVisitContextGlobalEvents, VisitComponentDefinitionContext } from "../parse-component-flavor";
/**
 * Custom element flavor.
 * This is the base flavor and affects many other flavors because it finds properties and definitions.
 */
export declare class CustomElementFlavor implements ParseComponentFlavor {
    visitComponentDefinitions(node: Node, context: VisitComponentDefinitionContext): void;
    parseDeclarationMembers(node: Node, context: ParseComponentMembersContext): ComponentMember[] | undefined;
    parseDeclarationEvents(node: Node, context: ParseComponentMembersContext): EventDeclaration[] | undefined;
    visitGlobalEvents(node: Node, context: ParseVisitContextGlobalEvents): void;
}
//# sourceMappingURL=custom-element-flavor.d.ts.map