import { getJsDoc, parseJsDocTagComment } from "../../util/js-doc-util";
export function parseJsDocForNode(node, tagName, transform, context) {
    const { ts } = context;
    const jsDoc = getJsDoc(node, ts);
    if (jsDoc != null && jsDoc.tags != null) {
        const items = jsDoc.tags
            .filter(tag => (Array.isArray(tagName) ? tagName : [tagName]).includes(tag.tag.toLowerCase()))
            .map(tag => {
            const parsed = parseJsDocTagComment(tag);
            return transform(tag.node, parsed);
        })
            .filter((item) => item != null);
        if (items.length > 0) {
            context.emitContinue && context.emitContinue();
            return items;
        }
    }
    return undefined;
}
