import { Node } from "typescript";
import { ComponentCSSProperty } from "../../types/component-css-property";
import { ComponentMember } from "../../types/component-member";
import { ComponentSlot } from "../../types/component-slot";
import { EventDeclaration } from "../../types/event-types";
import { ParseComponentFlavor, ParseComponentMembersContext, VisitComponentDefinitionContext } from "../parse-component-flavor";
/**
 * JsDoc Flavor.
 * This flavor only looks at jsdoc and continues the visiting flavors in children nodes after emitting members.
 */
export declare class JsDocFlavor implements ParseComponentFlavor {
    visitComponentDefinitions(node: Node, context: VisitComponentDefinitionContext): void;
    parseDeclarationMembers(node: Node, context: ParseComponentMembersContext): ComponentMember[] | undefined;
    parseDeclarationEvents(node: Node, context: ParseComponentMembersContext): EventDeclaration[] | undefined;
    parseDeclarationSlots(node: Node, context: ParseComponentMembersContext): ComponentSlot[] | undefined;
    parseDeclarationCSSProps(node: Node, context: ParseComponentMembersContext): ComponentCSSProperty[] | undefined;
}
//# sourceMappingURL=js-doc-flavor.d.ts.map