import { parseJsDocForNode } from "./helper";
/**
 * Parses @cssprop | @cssproperty js doc annotations on interface/class-like nodes.
 * @param node
 * @param context
 */
export function parseDeclarationCSSProps(node, context) {
    const { ts } = context;
    if (ts.isInterfaceDeclaration(node) || ts.isClassDeclaration(node)) {
        return parseJsDocForNode(node, ["cssprop", "cssproperty", "cssvar", "cssvariable"], (tagNode, parsed) => {
            if (parsed.name != null) {
                return {
                    name: parsed.name,
                    jsDoc: parsed.comment != null ? { comment: parsed.comment } : undefined
                };
            }
        }, context);
    }
    return undefined;
}
