import { FlavorVisitContext } from "../flavors/parse-component-flavor";
import { ComponentCSSProperty } from "../types/component-css-property";
import { ComponentDeclaration } from "../types/component-declaration";
import { ComponentMember } from "../types/component-member";
import { ComponentSlot } from "../types/component-slot";
import { EventDeclaration } from "../types/event-types";
/**
 * Merges multiple component declarations.
 * @param declarations
 * @param context
 */
export declare function mergeDeclarations(declarations: ComponentDeclaration[], context: FlavorVisitContext): ComponentDeclaration;
/**
 * Merges slots
 * @param slots
 */
export declare function mergeSlots(slots: ComponentSlot[]): ComponentSlot[];
/**
 * Merges events
 * @param events
 */
export declare function mergeEvents(events: EventDeclaration[]): EventDeclaration[];
/**
 * Merges css props
 * @param cssProps
 */
export declare function mergeCSSProps(cssProps: ComponentCSSProperty[]): ComponentCSSProperty[];
/**
 * Merges all members in the list of members.
 * @param members
 * @param context
 */
export declare function mergeMembers(members: ComponentMember[], context: FlavorVisitContext): ComponentMember[];
//# sourceMappingURL=merge-declarations.d.ts.map