/**
 * Merge jsdoc with a "main" jsdoc.
 * The main jsdoc keeps its comment.
 * The inherited js docs only extend with annotations.
 * @param mainJsDoc
 * @param inheritedJsDocs
 */
export function mergeJsDocs(mainJsDoc, inheritedJsDocs) {
    const jsDoc = inheritedJsDocs.reduce((jsDoc, extendJsDoc) => {
        if (extendJsDoc == null)
            return jsDoc;
        return Object.assign(Object.assign({}, jsDoc), { node: jsDoc.node, tags: [...(jsDoc.tags || []), ...(extendJsDoc.tags || [])] });
    }, mainJsDoc || {});
    if (jsDoc.comment == null && (jsDoc.tags == null || jsDoc.tags.length === 0))
        return undefined;
    return jsDoc;
}
