import { Node, SourceFile } from "typescript";
import { DefinitionNodeResult, FlavorVisitContext, ParseComponentFlavor } from "../flavors/parse-component-flavor";
import { ComponentDefinition } from "../types/component-definition";
/**
 * Visits the source file and finds all component definitions as "customElements.define".
 * Next it dedupes definitions and parses the corresponding component declaration for each definition.
 * @param sourceFile
 * @param flavors
 * @param context
 */
export declare function parseComponentDefinitions(sourceFile: SourceFile, flavors: ParseComponentFlavor[], context: FlavorVisitContext): ComponentDefinition[];
/**
 * Finds all component definitions in a file.
 * @param node
 * @param flavors
 * @param context
 */
export declare function parseComponentDefinitionResults(node: Node, flavors: ParseComponentFlavor[], context: FlavorVisitContext): DefinitionNodeResult[];
//# sourceMappingURL=parse-definitions.d.ts.map