/**
 * Visits the source file and finds all global event declarations in the file.
 * @param node
 * @param flavors
 * @param context
 */
export function parseGlobalEvents(node, flavors, context) {
    if (node == null)
        return [];
    const globalEvents = [];
    for (const flavor of flavors) {
        if (flavor.visitGlobalEvents == null)
            continue;
        flavor.visitGlobalEvents(node, Object.assign(Object.assign({}, context), { emitEvent(event) {
                globalEvents.push(event);
            } }));
    }
    return globalEvents;
}
