/**
 * The HTML spec defines what are valid characters in an attribute name {@link https://html.spec.whatwg.org/multipage/syntax.html#attributes-2}.
 * This helper functions ensures that the given input conforms to those rules
 * @param {string} name
 * @return {string}
 */
export declare function sanitizeAttributeName(name: string): string;
/**
 * Returns true if the given input is a valid attribute name
 * @param {string} input
 * @return {boolean}
 */
export declare function isValidAttributeName(input: string): boolean;
//# sourceMappingURL=is-valid-attribute-name.d.ts.map