import { SimpleType } from "ts-simple-type";
import * as tsModule from "typescript";
import { Node } from "typescript";
import { JsDoc, JsDocTag } from "../types/js-doc";
export interface ParsedJsDocTag {
    type?: string;
    name?: string;
    comment?: string;
}
/**
 * Parses a jsdoc tag into type, name and comment
 * @param tag
 */
export declare function parseJsDocTagComment(tag: JsDocTag | string): ParsedJsDocTag;
/**
 * Returns jsdoc for a given node.
 * @param node
 * @param ts
 */
export declare function getJsDoc(node: Node, ts: typeof tsModule): JsDoc | undefined;
/**
 * Converts a given string to a SimpleType
 * Defaults to ANY
 * See http://usejsdoc.org/tags-type.html
 * @param str
 */
export declare function parseJsDocTypeString(str: string): SimpleType;
/**
 * Finds a @type jsdoc tag in the jsdoc and returns the corresponding simple type
 * @param jsDoc
 */
export declare function getJsDocType(jsDoc: JsDoc): SimpleType | undefined;
//# sourceMappingURL=js-doc-util.d.ts.map