/**
 * Joins an array with a custom final splitter
 * @param items
 * @param splitter
 * @param finalSplitter
 */
export function joinArray(items, splitter = ", ", finalSplitter = "or") {
    return items.join(splitter).replace(/, ([^,]*)$/, ` ${finalSplitter} $1`);
}
/**
 * Converts from snake case to camel case
 * @param str
 */
export function dashToCamelCase(str) {
    return str.replace(/(\-\w)/g, m => m[1].toUpperCase());
}
/**
 * Converts from camel case to snake case
 * @param str
 */
export function camelToDashCase(str) {
    return str.replace(/[A-Z]/g, m => `-${m.toLowerCase()}`);
}
