import { WcaCliConfig } from "../../wca-cli-arguments";
import { CliCommand } from "../cli-command";
/**
 * A CLI command for analyzing components.
 */
export declare class AnalyzeCliCommand implements CliCommand {
    id: string;
    /**
     * Prints help for this command.
     */
    printHelp(): void;
    /**
     * Runs the analyze cli command.
     * @param config
     * @param inputGlobs
     */
    run(config: WcaCliConfig, ...inputGlobs: string[]): Promise<void>;
    /**
     * Analyzes input globs and returns the transformed result.
     * @param inputGlobs
     * @param config
     */
    analyze(inputGlobs: string | string[], config: WcaCliConfig): Promise<string>;
    /**
     * Transforms analyze results based on the wca cli config.
     * @param results
     * @param program
     * @param config
     */
    private transformResults;
}
//# sourceMappingURL=analyze-cli-command.d.ts.map